SLASH_ZONESEARCH1 = '/pz'
SLASH_PETSEARCH1 = '/ps'
SLASH_PETRARES1 = '/pr'
SLASH_PETTESTER1 = '/pt'
SLASH_BATTLESEARCH1 = '/pb'
SLASH_MYBATTLEPETNOTIFIER1 = '/ph'

local EventFrame = CreateFrame("Frame")
local colourTable = { 
   [1] = "|cFF8f8f8f",
   [2] = "|cFFffffff",
   [3] = "|cFF00ff00",
   [4] = "|cFF0080ff",
   [0] = "|cffff0000"
}
zones = {}
counter = 1

local function z(zone,min,max)
   zones[counter] = {zone,min,max}
   counter = counter + 1
end

gtt = GameTooltip
gtt:HookScript("OnToolTipSetUnit", function (self, event, ...)
      search, unit = gtt:GetUnit()
      x={};
      p = C_PetJournal;
      title = false
      for i=1,p.GetNumPets(false) do 
         id,_,_,_,l,_,_,n,_,_,_,d=p.GetPetInfoByIndex(i);
         if n == search and not x[n] then 
            if id>0 then 
               if not title then 
                  gtt:AddLine("")
                  gtt:AddLine("You have:")
                  title = true
               end
               gtt:AddLine("Level "..l.." "..p.GetBattlePetLink(id));
            else 
               gtt:AddLine("You don't have any "..n.."!")
               gtt:AddLine("Gotta catch one!")
            end 
            --x[n]=1;
         end 
      end
end)

red = colourTable[0]
grey =  colourTable[1]
white = colourTable[2]
green = colourTable[3]
blue = colourTable[4]
EventFrame:RegisterEvent("PET_BATTLE_OPENING_DONE")
EventFrame:SetScript("OnEvent", function(self,event,...) 
      if C_PetBattles.IsWildBattle(2,i) then
         SELECTED_CHAT_FRAME:AddMessage("|cFF5cb4f8 Battle Pet Notifier|r")
         p = C_PetJournal
         p.ClearSearchFilter(true)
         q = {}
         for i=1,C_PetBattles.GetNumPets(2) do
            c = 0
            lvl = C_PetBattles.GetLevel(2,i)
            o =  C_PetBattles.GetName(2,i)
            local Quality = C_PetBattles.GetBreedQuality(2,i)
            SELECTED_CHAT_FRAME:AddMessage("|cFFf9eb77 Wild Pet "..i..":|r "..colourTable[Quality]..C_PetBattles.GetName(2,i).."|r (L"..lvl..")") 
            
            
            for j=1, p.GetNumPets(false) do
               id,aa,_,_,level,_,_,n,_,_,_,d=p.GetPetInfoByIndex(j);
               if id > 0 and n == o then
                  c = c + 1;
                  print("You have: "..p.GetBattlePetLink(id).."|r (L"..level..")")
               end
            end
            if c == 0 then print ("You have no "..colourTable[0]..o.."|r!")
            end
         end
      end
end)
local function ZoneSearch(msg, editbox)
   --local class, spec = msg:match("^(%S*)%s*(.-)$");
   if msg == "" then 
      msg = GetZoneText()
   end
   
   x={};
   p = C_PetJournal;
   print("Searching for '"..msg.."' in the zone name..");
   
   for i=1,p.GetNumPets(false) do 
      id,_,_,_,_,_,_,n,_,_,_,d=p.GetPetInfoByIndex(i);
      if string.find(strlower(d), strlower(msg)) and not x[n] then 
         if id>0 then 
            print(p.GetBattlePetLink(id).." ");
         else 
            print(n.." "..d)
            x[n]=1;
         end 
      end 
   end
   z = ZoneLevelFinder(msg)
   if z ~= nil then
      for i=1,# z do
         zz=z[i]
         print(red..zz[1].." is L"..zz[2].."-"..zz[3].."|r")
      end
   end
   
end

local function PetSearch(msg, editbox)
   --local class, spec = msg:match("^(%S*)%s*(.-)$");
   if msg == "" then 
      print("Please put a pet name to seatch for!")
   else
      Search(msg)
   end
   
end
function Search(search)
   x={};
   p = C_PetJournal;
   print (colourTable[0].."Searching for  "..search.."...|r")
   for i=1,p.GetNumPets(false) do 
      id,_,_,_,l,_,_,n,_,_,_,d=p.GetPetInfoByIndex(i);
      if string.find(strlower(n), strlower(search)) and not x[n] then 
         if id>0 then 
            print(p.GetBattlePetLink(id).." (L"..l..")");
         else 
            print(n.." "..d)
            x[n]=1;
         end 
      end 
   end
end

local function BattlePetSearch(msg, editbox)
   print("I told you it's not yet implemented!  SHEESH!")
end

local function PetHelp(msg, editbox)
   print(colourTable[0].."Usage:|r")
   print("  Search for pets with 'keyword' term:")
   print(colourTable[0].."    /ps keyword")
   print(" ")
   print("  Search zones for pets:")
   print(colourTable[0].."    /pz [search]|r")
   print("If /pz  is run without a search term, only the local zone is scanned")
   print(" ")
   print("  Search only battlable pets in a zone (not yet implemented)")
   print(colourTable[0].."    /pb [search]|r")
   print(" ")
   print("  Rare Collection: (show which rares you need for the zone - not yet implemented)")
   print(colourTable[0].."    /pr [zone]|r")
   print(" ")
   print("  Help: (this screen)")
   print(colourTable[0].."    /ph|r")
   
end

local function PetRares(msg, editbox)
   --local class, spec = msg:match("^(%S*)%s*(.-)$");
   if msg == "" then 
      msg = GetZoneText()
   end
   
   x={};
   p = C_PetJournal;
   name = ""
   print(red.."Scanning for rares in '"..msg.."':|r");
   name = ""
   rare = false
   newName = true
   rares = {}
   for i=1,p.GetNumPets(false)do
      id,_,_,_,l,_,_,n,_,_,_,d,_,b=p.GetPetInfoByIndex(i);
      if id > 0 then
         _,_,_,_,r = p.GetPetStats(id)
         if r > 3 and b then
            rares[n] = true
            --print(n.." "..l..r)
         end
      end
   end
   
   for i=1,p.GetNumPets(false) do 
      id,_,_,_,l,_,_,n,_,_,_,d,_,b=p.GetPetInfoByIndex(i);
      if string.find(strlower(d), strlower(msg)) and string.find(strlower(d), "pet battle:") and not x[n] then 
         if id>0 then 
            _,_,_,_,r = p.GetPetStats(id)
            if rares[n] then
               if r > 3 then
                  print("You have "..p.GetBattlePetLink(id).." (L"..l..")");
                  x[n]=1;
               else
               end
            else
               print("Have non-rare "..n.." (L"..l..")")
               x[n]=1;
            end
         else 
            print("Need rare "..n)
            x[n]=1;
         end 
      end 
   end
   z = ZoneLevelFinder(msg)
   if z ~= nil then
      for i=1,# z do
         zz=z[i]
         print(red..zz[1].." is L"..zz[2].."-"..zz[3].."|r")
      end
   end

end
function ZoneLevelFinder(msg)
   c = 1
   z = {}
   for i=1,# zones do
      zone = zones[i]
      if string.find(strlower(zone[1]), strlower(msg)) then
         z[c]={zone[1],zone[2],zone[3]}
         c = c + 1
      end
   end
   return z
end

local function PetTester(msg, editbox)
   print("test")
   
   --local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle = C_PetJournal.GetPetInfoByIndex(1, PetJournal.isWild)
   --local health, maxHealth, attack, speed, rarity = C_PetJournal.GetPetStats(petID)
   --print(colourTable[rarity]..name.."|r")
   for i=1,# zones do
      zone = zones[i]
      if string.find(strlower(zone[1]), strlower(msg)) then
         print(zone[1]..": Level "..zone[2].."-"..zone[3])
      end
   end
end

SlashCmdList["ZONESEARCH"] = ZoneSearch;
SlashCmdList["PETSEARCH"] = PetSearch;
SlashCmdList["PETRARES"] = PetRares;
--SlashCmdList["PETTESTER"] = PetTester;
SlashCmdList["BATTLESEARCH"] = BattlePetSearch;
SlashCmdList["MYBATTLEPETNOTIFIER"] = PetHelp;






z("Azuremyst Isle",1,2)
z("Durotar",1,2)
z("Teldrassil",1,2)
z("Darnassus",1,2)
z("Exodar",1,2)
z("Mulgore",1,2)
z("Orgrimmar",1,2)
z("Northern Barrens",3,4)
z("Ashenvale",4,5)
z("Azshara",3,5)
z("Bloodmyst Isle",3,5)
z("Darkshore",3,5)
z("Stonetalon Mountains",5,6)
z("Desolace",7,8)
z("Southern Barrens",9,10)
z("Feralas",11,12)
z("Dustwallow Marsh",12,13)
z("Tanaris",13,14)
z("Thousand Needles",13,14)
z("Felwood",14,15)
z("Moonglade",15,16)
z("Un'Goro Crater",15,16)
z("Ahn'Qiraj: The Fallen Kingdom",16,17)
z("Silithus",16,17)
z("Winterspring",17,18)
z("Mount Hyjal",22,23)
z("Uldum",23,24)
z("Dun Morogh",1,2)
z("Elwynn Forest",1,2)
z("Eversong Woods",1,2)
z("Tirisfal Glade",1,2)
z("Ironforge",1,2)
z("Silvermoon City",1,2)
z("Stormwind",1,2)
z("Undercity",1,2)
z("Westfall",3,4)
z("Ghostlands",3,5)
z("Loch Modan",3,5)
z("Redridge Mountains",4,5)
z("Silverpine Forest",3,5)
z("Duskwood",5,6)
z("Hillsbrad Foothills",6,7)
z("Wetlands",6,7)
z("Arathi Highlands",7,8)
z("Northern Stranglethorn Vale",7,8)
z("The Cape of Stranglethorn",9,10)
z("Western Plaguelands",10,11)
z("The Hinterlands",11,12)
z("Eastern Plaguelands",12,13)
z("Badlands",13,14)
z("Searing Gorge",13,14)
z("Swamp of Sorrows",14,15)
z("Burning Steppes",15,16)
z("Blasted Lands",16,17)
z("Deadwind Pass",17,18)
z("Twilight Highlands",23,24)
z("Deepholm",22,23)
z("Hellfire Penninsula",17,18)
z("Nagrand",18,19)
z("Terrokar",18,19)
z("Zangarmarsh",18,19)
z("Blade's Edge",18,19)
z("Netherstorm",20,21)
z("Shadowmoon Valley",20,21)
z("Borean Tundra",20,21)
z("Grizzly Hills",21,22)
z("Howling Fjord",20,21)
z("Scholazar Basin",21,22)
z("Crystalsong Forest",22,23)
z("Dragonblight",22,23)
z("Icecrown",22,23)
z("Storm Peaks",22,23)
z("Zul'drak",22,23)
z("Dread Wastes",24,24)
z("Krasarang Wilds",23,24)
z("Kun'Lai Summit",23,24)
z("The Jade Forest",23,24)
z("Townlong Steppes",24,24)
z("Vale of Eternal Blossoms",24,24)
z("Valley of the Four Winds",23,24)